<!-- 
# Copyright 2019 Xilinx Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
-->

<table width="100%">
 <tr width="100%">
    <td align="center"><img src="https://www.xilinx.com/content/dam/xilinx/imgs/press/media-kits/corporate/xilinx-logo.png" width="30%"/><h1>Advantages of Inter-Kernel Communication and Platform Agnostic Tools</h1>
    </td>
 </tr>
</table>

***Version: 2019.2***

Code for the "Advantages of Inter-Kernel Communication and Platform Agnostic Tools" article on the Developer//Xilinx (https://developer.xilinx.com/)
https://developer.xilinx.com/en/articles/advantages-of-inter-kernel-communication-and-platform-agnostic-tools.html

## Introduction
This tutorial demonstrates the acceleration advantages of the The Xilinx® Vitis™ unified software platform Vitis Vision Library and kernel-to-kernel streaming as well as how a single set of high-level code can be implemented on a datacenter (Alveo) or Embedded (MPSoC) platform.  Vitis Vision is hardware-accelerated OpenCV functions optimized for Xilinx SoCs and FPGAs; the functions are written completely in C/C++ and targeted for High-level Synthesis (HLS).

## Tutorial Overview
Vitis is a unified software platform that uses the same OpenCL API calls to target either an embedded or datacenter platform.  This tutorial will utilize OpenCV/OpenCL to demonstrate the performance gains when utilizing the Vitis Vision Library and kernel-to-kernel streaming.  This tutorial will also show that the code is platform agnostic.  Managing the dataflow in the kernel space is key to achieving high performance accelerated designs.

The C code will be targeted towards AVB application and will include a color space converter (cvtcolor) and scalar (resize) utilizing the Vitis Vision Library.  The input source file-based image (can also be video stream mp4) which will be converted into an AXI memory or an AXI stream dataflow with functions from the OpenCV library.  

<p align="center"><img src="./img/Fig1.png"/></p>
<p align="center">Figure 1 - High-level reference design concept</p>

Overall dataflow of acceleration kernels is done in two ways for this tutorial.
##
<p align="center"><sup>Copyright&copy; 2019 Xilinx</sup></p>
